#include <Wire.h>
#include <sCtrl.h>

#define SCTRL_ARDUINO_LED_13       0xF001
#define SCTRL_ARDUINO_LED_13_SIZE     (1)

void setup()
{
    Wire.begin();
    sCtrl.begin();
    Serial.begin(115200);
    pinMode(13, OUTPUT);
    digitalWrite(13, LOW);
}

void loop()
{
    byte led13;
  
    while(sCtrl.receive()) {
        if (sCtrl.parse())
        {
            if (sCtrl.src_addr == 0x0003               && 
                sCtrl.action   == SCTRL_REPORT         && 
                sCtrl.reg      == SCTRL_ARDUINO_LED_13 && 
                sCtrl.val_len  == SCTRL_ARDUINO_LED_13_SIZE)
            {
                if (sCtrl.pval[0] == HIGH)
                {
                    digitalWrite(13, HIGH);
                    Serial.println("ON");
                }
                else if (sCtrl.pval[0] == LOW)
                {
                    digitalWrite(13, LOW);
                    Serial.println("OFF");
                }
            }
        }
    }
    
    if (digitalRead(13) == HIGH) {
        led13 = LOW;
    } else {
        led13 = HIGH;
    }
    
    sCtrl.set(0x0003, SCTRL_ARDUINO_LED_13, &led13, SCTRL_ARDUINO_LED_13_SIZE);
    delay(500);
}

