#include <Wire.h>
#include <sCtrl.h>

#define  SCTRL_ARDUINO_LED_13               (0xF001)
#define  SCTRL_ARDUINO_LED_13_SIZE               (1)

void setup()
{
    Wire.begin();
    sCtrl.begin();
    Serial.begin(115200);
    pinMode(13, OUTPUT);
}

void loop()
{
    byte led13;

    while(sCtrl.receive()) {
        if (sCtrl.parse())
        {
            if (sCtrl.src_addr == 0x0001               &&
                sCtrl.reg      == SCTRL_ARDUINO_LED_13 &&
                sCtrl.val_len  == SCTRL_ARDUINO_LED_13_SIZE)
            {
                switch (sCtrl.action)
                {
                case SCTRL_GET:
                    led13 = digitalRead(13);
                    sCtrl.report(sCtrl.src_addr, SCTRL_ARDUINO_LED_13, &led13, SCTRL_ARDUINO_LED_13_SIZE);
                    break;

                case SCTRL_SET:
                    if (sCtrl.pval[0] == HIGH)
                    {
                        digitalWrite(13, HIGH);
                        Serial.println("ON");
                        led13 = digitalRead(13);
                        sCtrl.report(sCtrl.src_addr, SCTRL_ARDUINO_LED_13, &led13, SCTRL_ARDUINO_LED_13_SIZE);
                    }
                    else if (sCtrl.pval[0] == LOW)
                    {
                        digitalWrite(13, LOW);
                        Serial.println("OFF");
                        led13 = digitalRead(13);
                        sCtrl.report(sCtrl.src_addr, SCTRL_ARDUINO_LED_13, &led13, SCTRL_ARDUINO_LED_13_SIZE);
                    }
                    break;

                default:
                    break;
                }
            }
        }
    }
}

