#ifndef _SCTRL_H_
#define _SCTRL_H_

#define  SCTRL_RX_BUF_SIZE        (21)

#define  SCTRL_GET              (0x01)
#define  SCTRL_SET              (0x02)
#define  SCTRL_REPORT           (0x11)

typedef struct
{
	uint16_t addr;
	uint8_t  action;
	uint16_t reg;
	uint8_t  pval[1];
} sCtrl_Msg_t;

class sCtrl_Class
{
    public:
        sCtrl_Class              (uint8_t addr);

        void      begin          ();
        void      send           (uint16_t dst_addr, uint8_t *pdata, uint8_t data_len);
        uint8_t   receive        ();
        uint8_t   parse          ();
        void      get            (uint16_t addr, uint16_t reg);
        void      set            (uint16_t addr, uint16_t reg, uint8_t *pval, uint8_t val_len);
        void      report         (uint16_t addr, uint16_t reg, uint8_t *pval, uint8_t val_len);

        uint8_t   INT8U          (uint8_t *ptr);
        uint16_t  INT16U         (uint8_t *ptr);

        uint8_t  *pINT8U         (uint8_t  val)
        {
            return &val;
        }

        uint8_t  *pINT16U        (uint16_t val)
        {
            return (uint8_t *)&val;
        }

        uint8_t   buf[SCTRL_RX_BUF_SIZE];
        uint8_t   len;
        uint16_t  src_addr;
        uint8_t  *pdata;
        uint8_t   data_len;
        uint8_t   action;
        uint16_t  reg;
        uint8_t  *pval;
        uint8_t   val_len;

    private:
        void    write          (uint8_t action, uint16_t addr, uint16_t reg, uint8_t *pval, uint8_t val_len);

        uint8_t i2c_addr;
};

extern sCtrl_Class sCtrl;
#endif
